<template>
  <div>
    <div class="course-info">
      <h3>{{ course.name }}</h3>
      <p>{{ course.description }}</p>
      <p>by {{ course.owners.nodes[0].user.name }}</p>
      <p>
        <el-button
          size="mini"
          @click="$router.push(`/run/course?id=${course.id}`)"
          >Run</el-button
        >
        <el-button
          size="mini"
          v-if="course.writeable"
          @click="$router.push(`/courses/${course.id}/edit`)"
          >Edit</el-button
        >
        <el-button
          size="mini"
          v-if="course.printConfig && course.printConfig.pages.length > 0"
          @click="$router.push(`/print/${course.id}`)"
          >Print</el-button
        >
        <feature-guard feature="run-in-app">
          <el-button
            size="mini"
            @click="$router.push(`/app/course/${course.id}`)"
            >Run in App</el-button
          >
        </feature-guard>
      </p>
      <p>
        Get directions to the start using:
        <external-map-link
          :location="course.startCheckpoint"
          v-if="course.startCheckpoint"
        />.<br />Note: if the start point is "off the beaten path", Apple and
        Google both have a pretty bad sense of what roads are worth trying in a
        car, so you may want to be careful as you approach!
      </p>

      <h4>Checkpoints</h4>
      <div class="checkpoints-list">
        <div class="cp" v-for="cp in course.checkpoints.nodes" :key="cp.id">
          <span class="name">{{ cp.name }}</span>
          <span class="description">{{ cp.description }}</span>
        </div>
      </div>

      <h4>Leaderboard</h4>
      <CourseLeaderboard :course-id="course.id" :count="5" />
    </div>
    <portal to="map">
      <Checkpoint
        ref="markers"
        v-for="cp in course.checkpoints.nodes"
        :key="cp.id"
        :value="cp"
        @dblclick.stop.prevent
      >
        <MglPopup height="130" :offset="[0, -10]">
          <div>
            <h3>{{ cp.name }}</h3>
            <p>{{ cp.description }}</p>
          </div>
        </MglPopup>
      </Checkpoint>

      <MglConfig :items="course.checkpoints.nodes" />
    </portal>
  </div>
</template>
<style lang="scss" scoped>
@import "~assets/mixins";

.course-info {
  pointer-events: initial;
  background-color: $color-background;
  color: white;
  padding: $grid * 0.25;

  width: $grid * 15;
  max-width: 90vw;

  max-height: 80vh;
  overflow: auto;
}

.checkpoints-list {
  display: flex;
  flex-direction: column;

  .cp {
    display: flex;
    flex-direction: row;
    align-items: center;
    margin-bottom: $grid/2;
  }

  .name {
    font-weight: 600;
    margin-right: $grid * 0.5;
  }
}
</style>
<script>
import { query } from "~/plugins/data-management";
import MglConfig from "~/components/mapping/MglConfig";
import Checkpoint from "~/components/mapping/Checkpoint";
import ExternalMapLink from "../../../components/ExternalMapLink.vue";

const FIELDS = `fragment fields on Course { 
  id name description public printConfig writeable
  owners:courseUsers(condition: { owner: true }, first: 1) {
    nodes {
      user {
        id name avatarUrl
      }
    }
  }
  checkpoints:checkpoints(orderBy: [NAME_ASC]) { nodes { id name description lat lng radius }  }
  startCheckpoint { id name description lat lng }
}`;

const GET =
  `query($id: UUID!) {
  course : course(id: $id) { ...fields } 
}` + FIELDS;

export default {
  asyncData: async (ctx) => {
    const res = await query(GET, ({ route }) => ({ id: route.params.id }))(ctx);
    if (res.course == null) return ctx.error("404 - Course Not Found");
    return res;
  },
  components: {
    MglConfig,
    Checkpoint,
    "external-map-link": ExternalMapLink,
    CourseLeaderboard: () =>
      import("./-CourseLeaderboard").then((d) => d.default || d),
  },
};
</script>
